com.smartgwt.client.widgets.form.fields

## Class RelativeDateItem

- java.lang.Object
- - com.smartgwt.client.core.JsObject
  - - com.smartgwt.client.core.DataClass
    - - com.smartgwt.client.core.RefDataClass
      - - com.smartgwt.client.widgets.form.fields.FormItem
        - - com.smartgwt.client.widgets.form.fields.CanvasItem
          - - com.smartgwt.client.widgets.form.fields.RelativeDateItem

- All Implemented Interfaces:
    com.google.gwt.event.shared.HasHandlers, HasBlurHandlers, HasCanEditChangedHandlers, HasChangedHandlers, HasChangeHandlers, HasClickHandlers, HasDoubleClickHandlers, HasEditorEnterHandlers, HasEditorExitHandlers, HasFocusHandlers, HasIconClickHandlers, HasIconKeyPressHandlers, HasItemHoverHandlers, HasKeyDownHandlers, HasKeyPressHandlers, HasKeyUpHandlers, HasPendingStatusChangedHandlers, HasPickerIconClickHandlers, HasReadOnlyDisplayChangedHandlers, HasShowContextMenuHandlers, HasShowValueHandlers, HasTitleClickHandlers, HasTitleDoubleClickHandlers, HasTitleHoverHandlers, HasValueHoverHandlers, HasValueIconClickHandlers

      public class RelativeDateItem
      extends CanvasItem

  A FormItem for entering a date relative to today or relative to some other date, or a specific date. Typically used for filtering data by date.

  The RelativeDateItem consists of a `ComboBoxItem` where the user may directly choose one of several `preset options`, choose to enter a `quantity` and `time unit` (eg "4 months ago" or "3 years from now") or directly type in an absolute date value (7/18/2009).

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from class com.smartgwt.client.widgets.form.fields.FormItem

      `FormItem.CustomStateGetter, FormItem.StateCustomizer`

  - ### Field Summary

    - ### Fields inherited from class com.smartgwt.client.widgets.form.fields.FormItem

      `configOnly, scClassName, warnOnEditorTypeConversion, warnOnEditorTypeConversionDefault`

    - ### Fields inherited from class com.smartgwt.client.core.RefDataClass

      `id`

    - ### Fields inherited from class com.smartgwt.client.core.DataClass

      `factoryCreated, factoryProperties`

    - ### Fields inherited from class com.smartgwt.client.core.JsObject

      `jsObj`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `RelativeDateItem()`
    `RelativeDateItem(com.google.gwt.core.client.JavaScriptObject jsObj)`
    `RelativeDateItem(java.lang.String name)`
    `RelativeDateItem(java.lang.String name, java.lang.String title)`

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `static void` | `changeAutoChildDefaults(java.lang.String autoChildName, Canvas defaults)` Changes the defaults for Canvas AutoChildren named `autoChildName`.
    `static void` | `changeAutoChildDefaults(java.lang.String autoChildName, FormItem defaults)` Changes the defaults for FormItem AutoChildren named `autoChildName`.
    `static void` | `changePickerIconDefaults(FormItemIcon defaults)`
    `void` | `formatEditorValue()` RelativeDateItems do not make use of the standard `FormItem.formatEditorValue()` and `FormItem.parseEditorValue()` methods.
    `static java.util.Date` | `getAbsoluteDate(RelativeDate relativeDate)` Converts a RelativeDate to a concrete Date.
    `static java.util.Date` | `getAbsoluteDate(RelativeDate relativeDate, java.util.Date baseDate)` Converts a RelativeDate to a concrete Date.
    `java.lang.Boolean` | `getAllowAbsoluteDates()` When set to false, only relative dates can be entered - in this mode, the `date chooser icon` is hidden and the `value field` is switched from a `ComboBoxItem`, which allows text-entry, to a `SelectItem` which does not.
    `java.util.Date` | `getBaseDate()` Base date for calculating the relative date entered by the user.
    `BlurbItem` | `getCalculatedDateField()` Field that shows the current calculated date by adding the user-entered relative date to the `baseDate`.
    `int` | `getCenturyThreshold()` Only used if we're showing the date in a text field.
    `java.lang.String` | `getDaysAgoTitle()` The title to show for historical periods when the `TimeUnit` is "day".
    `java.lang.String` | `getDaysFromNowTitle()` The title to show for future periods when the `TimeUnit` is "day".
    `int` | `getDefaultQuantity()` Default quantity to show in the `quantityField`.
    `java.util.Date` | `getEndDate()` Maximum date the selectors will allow the user to pick.
    `void` | `getEnteredValue()` Returns the raw text value typed into this items value text field
    `FiscalCalendar` | `getFiscalCalendar()` Returns the `FiscalCalendar` object that will be used by this item's DateChooser.
    `java.lang.String` | `getHoursAgoTitle()` The title to show for historical periods when the `TimeUnit` is "hour".
    `java.lang.String` | `getHoursFromNowTitle()` The title to show for future periods when the `TimeUnit` is "hour".
    `java.lang.String` | `getInputFormat()` Format for direct user input of date values.
    `int` | `getMaxQuantity()` Maximum value to allow in the `quantityField`.
    `java.lang.String` | `getMillisecondsAgoTitle()` The title to show for historical periods when the `TimeUnit` is "millisecond".
    `java.lang.String` | `getMillisecondsFromNowTitle()` The title to show for future periods when the `TimeUnit` is "millisecond".
    `int` | `getMinQuantity()` Minimum value to allow in the `quantityField`.
    `java.lang.String` | `getMinutesAgoTitle()` The title to show for historical periods when the `TimeUnit` is "minute".
    `java.lang.String` | `getMinutesFromNowTitle()` The title to show for future periods when the `TimeUnit` is "minute".
    `java.lang.String` | `getMonthsAgoTitle()` The title to show for historical periods when the `TimeUnit` is "month".
    `java.lang.String` | `getMonthsFromNowTitle()` The title to show for future periods when the `TimeUnit` is "month".
    `OperatorId` | `getOperator()` What operator to use when the `FormItemCriterionGetter`'s `getCriterion()` method is called.
    `static RelativeDateItem` | `getOrCreateRef(com.google.gwt.core.client.JavaScriptObject jsObj)`
    `java.lang.String` | `getPickerConstructor()` Smart GWT class for the `dateChooser` autoChild displayed to allow the user to directly select dates.
    `FormItemIcon` | `getPickerIcon()` Icon that launches a `DateChooser` for choosing an absolute date.
    `java.lang.String` | `getPickerIconPrompt()` Prompt to show when the user hovers the mouse over the picker icon for this RelativeDateItem.
    `TimeItem` | `getPickerTimeItemProperties()` A set of properties to apply to the `TimeItem` displayed in the picker when `showPickerTimeItem` is true.
    `SpinnerItem` | `getQuantityField()` Field allowing user to pick units of time, eg, number of days.
    `java.lang.String` | `getQuartersAgoTitle()` The title to show for historical periods when the `TimeUnit` is "quarter".
    `java.lang.String` | `getQuartersFromNowTitle()` The title to show for future periods when the `TimeUnit` is "quarter".
    `RelativeDateRangePosition` | `getRangePosition()` Does this items relative date value refer to the start or end of the chosen date? Useful when using this item to generate filter criteria, such as the from or to value for an inclusive range.
    `RelativeDate` | `getRelativeDate()` Returns the RelativeDate for the current value.
    `java.lang.String` | `getSecondsAgoTitle()` The title to show for historical periods when the `TimeUnit` is "second".
    `java.lang.String` | `getSecondsFromNowTitle()` The title to show for future periods when the `TimeUnit` is "second".
    `java.lang.Boolean` | `getShouldSaveValue()` Should this item's value be saved in the form's values and hence returned from `form.getValues()`?
    `java.lang.Boolean` | `getShowCalculatedDateField()` Should the Calculated-Date be displayed to the right of the `pickerIcon`.
    `java.lang.Boolean` | `getShowChooserFiscalYearPicker()` When set to true, show a button that allows the calendar to be navigated by fiscal year.
    `java.lang.Boolean` | `getShowChooserIcon()` Should we show the icon that displays a date-chooser?
    `java.lang.Boolean` | `getShowChooserWeekPicker()` When set to true, show a button that allows the calendar to be navigated by week or fiscal week, depending on the value of `showChooserFiscalYearPicker`.
    `java.lang.Boolean` | `getShowFutureOptions()` Should we show time-unit options in the future? If set to false, for each `timeUnitOption` we will show only past options [for example "N weeks ago"].
    `java.lang.Boolean` | `getShowPastOptions()` Should we show time-unit options in the past? If set to false, for each `timeUnitOption` we will show only future options [for example "N weeks from now"].
    `java.lang.Boolean` | `getShowPickerTimeItem()` If this item is editing a field of type `"datetime"`, should the `DateChooser` display the `time field`, allowing the user to select a time?
    `java.util.Date` | `getStartDate()` Minimum date the selectors will allow the user to pick.
    `TimeUnit[]` | `getTimeUnitOptions()` List of time units that will be offered for relative dates.
    `java.lang.Boolean` | `getUse24HourTime()` When showing the `DateChooser`, should the `time field` be set to use 24-hour time? Has no effect for fields of type `"date"` rather than `"datetime"`, or if `showPickerTimeItem` is `false`.
    `java.lang.Boolean` | `getUseSharedPicker()` When set to true (the default), use a single shared date-picker across all widgets that use one.
    `ComboBoxItem` | `getValueFieldComboBox()` `ComboBoxItem` field where a user may choose among `presets`, `time unit` plus `quantity`, or direct entry of a date as text.
    `int` | `getValueFieldWidth()` The `width` for the `valueField` in this item.
    `java.lang.String` | `getValueFieldWidthAsString()` The `width` for the `valueField` in this item.
    `java.lang.String` | `getWeeksAgoTitle()` The title to show for historical periods when the `TimeUnit` is "week".
    `java.lang.String` | `getWeeksFromNowTitle()` The title to show for future periods when the `TimeUnit` is "week".
    `java.lang.String` | `getYearsAgoTitle()` The title to show for historical periods when the `TimeUnit` is "year".
    `java.lang.String` | `getYearsFromNowTitle()` The title to show for future periods when the `TimeUnit` is "year".
    `void` | `parseEditorValue()` RelativeDateItems do not make use of the standard `FormItem.formatEditorValue()` and `FormItem.parseEditorValue()` methods.
    `void` | `setAllowAbsoluteDates(java.lang.Boolean allowAbsoluteDates)` When set to false, only relative dates can be entered - in this mode, the `date chooser icon` is hidden and the `value field` is switched from a `ComboBoxItem`, which allows text-entry, to a `SelectItem` which does not.
    `void` | `setBaseDate(java.util.Date baseDate)` Base date for calculating the relative date entered by the user.
    `void` | `setCenturyThreshold(int centuryThreshold)` Only used if we're showing the date in a text field.
    `void` | `setDateFormatter(DateDisplayFormat dateFormatter)` Format for displaying dates in the `valueField` and `calculatedDateField`.
    `void` | `setDateFormatter(DateDisplayFormatter formatter)` Formatter function for displaying dates in the `valueField` and `calculatedDateField` in some custom format.
    `void` | `setDateParser(DateParser parser)` Custom date parser function for direct user input of date values.
    `void` | `setDaysAgoTitle(java.lang.String daysAgoTitle)` The title to show for historical periods when the `TimeUnit` is "day".
    `void` | `setDaysFromNowTitle(java.lang.String daysFromNowTitle)` The title to show for future periods when the `TimeUnit` is "day".
    `static void` | `setDefaultProperties(RelativeDateItem relativeDateItemProperties)` Class level method to set the default properties of this class.
    `void` | `setDefaultQuantity(int defaultQuantity)` Default quantity to show in the `quantityField`.
    `void` | `setEditorValueFormatter(FormItemValueFormatter formatter)` RelativeDateItems do not make use of the standard FormItem.setEditorValueFormatter() and FormItem.setEditorValueParser() methods.
    `void` | `setEditorValueParser(FormItemValueParser parser)` RelativeDateItems do not make use of the standard FormItem.setEditorValueFormatter() and FormItem.setEditorValueParser() methods.
    `void` | `setEndDate(java.util.Date endDate)` Maximum date the selectors will allow the user to pick.
    `void` | `setFiscalCalendar()` Sets the `FiscalCalendar` object that will be used by this item's DateChooser.
    `void` | `setFiscalCalendar(FiscalCalendar fiscalCalendar)` Sets the `FiscalCalendar` object that will be used by this item's DateChooser.
    `void` | `setHoursAgoTitle(java.lang.String hoursAgoTitle)` The title to show for historical periods when the `TimeUnit` is "hour".
    `void` | `setHoursFromNowTitle(java.lang.String hoursFromNowTitle)` The title to show for future periods when the `TimeUnit` is "hour".
    `void` | `setInputFormat(java.lang.String inputFormat)` Format for direct user input of date values.
    `void` | `setMaxQuantity(int maxQuantity)` Maximum value to allow in the `quantityField`.
    `void` | `setMillisecondsAgoTitle(java.lang.String millisecondsAgoTitle)` The title to show for historical periods when the `TimeUnit` is "millisecond".
    `void` | `setMillisecondsFromNowTitle(java.lang.String millisecondsFromNowTitle)` The title to show for future periods when the `TimeUnit` is "millisecond".
    `void` | `setMinQuantity(int minQuantity)` Minimum value to allow in the `quantityField`.
    `void` | `setMinutesAgoTitle(java.lang.String minutesAgoTitle)` The title to show for historical periods when the `TimeUnit` is "minute".
    `void` | `setMinutesFromNowTitle(java.lang.String minutesFromNowTitle)` The title to show for future periods when the `TimeUnit` is "minute".
    `void` | `setMonthsAgoTitle(java.lang.String monthsAgoTitle)` The title to show for historical periods when the `TimeUnit` is "month".
    `void` | `setMonthsFromNowTitle(java.lang.String monthsFromNowTitle)` The title to show for future periods when the `TimeUnit` is "month".
    `void` | `setOperator(OperatorId operator)` What operator to use when the `FormItemCriterionGetter`'s `getCriterion()` method is called.
    `void` | `setPickerConstructor(java.lang.String pickerConstructor)` Smart GWT class for the `dateChooser` autoChild displayed to allow the user to directly select dates.
    `void` | `setPickerIconPrompt(java.lang.String pickerIconPrompt)` Prompt to show when the user hovers the mouse over the picker icon for this RelativeDateItem.
    `void` | `setPickerTimeItemProperties(TimeItem pickerTimeItemProperties)` A set of properties to apply to the `TimeItem` displayed in the picker when `showPickerTimeItem` is true.
    `void` | `setPresetOptions(java.util.LinkedHashMap valueMap)` Set up a set of standard relative dates such as "today" or "tomorrow" that the user can choose directly from the valueField of this item.
    `void` | `setQuartersAgoTitle(java.lang.String quartersAgoTitle)` The title to show for historical periods when the `TimeUnit` is "quarter".
    `void` | `setQuartersFromNowTitle(java.lang.String quartersFromNowTitle)` The title to show for future periods when the `TimeUnit` is "quarter".
    `void` | `setRangePosition(RelativeDateRangePosition rangePosition)` Does this items relative date value refer to the start or end of the chosen date? Useful when using this item to generate filter criteria, such as the from or to value for an inclusive range.
    `void` | `setRangeRoundingGranularity(java.util.Map rangeRoundingGranularity)` A map from a granularity of time specified by a user to the granularity of time used for rounding.
    `void` | `setSecondsAgoTitle(java.lang.String secondsAgoTitle)` The title to show for historical periods when the `TimeUnit` is "second".
    `void` | `setSecondsFromNowTitle(java.lang.String secondsFromNowTitle)` The title to show for future periods when the `TimeUnit` is "second".
    `void` | `setShouldSaveValue(java.lang.Boolean shouldSaveValue)` Should this item's value be saved in the form's values and hence returned from `form.getValues()`?
    `void` | `setShowCalculatedDateField(java.lang.Boolean showCalculatedDateField)` Should the Calculated-Date be displayed to the right of the `pickerIcon`.
    `void` | `setShowChooserFiscalYearPicker(java.lang.Boolean showChooserFiscalYearPicker)` When set to true, show a button that allows the calendar to be navigated by fiscal year.
    `void` | `setShowChooserIcon(java.lang.Boolean showChooserIcon)` Should we show the icon that displays a date-chooser?
    `void` | `setShowChooserWeekPicker(java.lang.Boolean showChooserWeekPicker)` When set to true, show a button that allows the calendar to be navigated by week or fiscal week, depending on the value of `showChooserFiscalYearPicker`.
    `void` | `setShowFutureOptions(java.lang.Boolean showFutureOptions)` Should we show time-unit options in the future? If set to false, for each `timeUnitOption` we will show only past options [for example "N weeks ago"].
    `void` | `setShowPastOptions(java.lang.Boolean showPastOptions)` Should we show time-unit options in the past? If set to false, for each `timeUnitOption` we will show only future options [for example "N weeks from now"].
    `void` | `setShowPickerTimeItem(java.lang.Boolean showPickerTimeItem)` If this item is editing a field of type `"datetime"`, should the `DateChooser` display the `time field`, allowing the user to select a time?
    `void` | `setStartDate(java.util.Date startDate)` Minimum date the selectors will allow the user to pick.
    `void` | `setTimeUnitOptions(TimeUnit... timeUnitOptions)` List of time units that will be offered for relative dates.
    `void` | `setUse24HourTime(java.lang.Boolean use24HourTime)` When showing the `DateChooser`, should the `time field` be set to use 24-hour time? Has no effect for fields of type `"date"` rather than `"datetime"`, or if `showPickerTimeItem` is `false`.
    `void` | `setUseSharedPicker(java.lang.Boolean useSharedPicker)` When set to true (the default), use a single shared date-picker across all widgets that use one.
    `void` | `setValueFieldWidth(int valueFieldWidth)` The `width` for the `valueField` in this item.
    `void` | `setValueFieldWidth(java.lang.String valueFieldWidth)` The `width` for the `valueField` in this item.
    `void` | `setWeeksAgoTitle(java.lang.String weeksAgoTitle)` The title to show for historical periods when the `TimeUnit` is "week".
    `void` | `setWeeksFromNowTitle(java.lang.String weeksFromNowTitle)` The title to show for future periods when the `TimeUnit` is "week".
    `void` | `setYearsAgoTitle(java.lang.String yearsAgoTitle)` The title to show for historical periods when the `TimeUnit` is "year".
    `void` | `setYearsFromNowTitle(java.lang.String yearsFromNowTitle)` The title to show for future periods when the `TimeUnit` is "year".

    - ### Methods inherited from class com.smartgwt.client.widgets.form.fields.CanvasItem

      `addCanEditChangedHandler, addReadOnlyDisplayChangedHandler, addShowValueHandler, createCanvas, getApplyPromptToCanvas, getAutoDestroy, getCanvas, getEditCriteriaInInnerForm, getHeight, getHeightAsString, getMaxHeight, getMinHeight, getMultiple, getOverflow, getPrompt, hasAdvancedCriteria, isFocused, setApplyPromptToCanvas, setAutoDestroy, setCanEditCriterionPredicate, setCanvas, setCriterionGetter, setCriterionSetter, setDefaultProperties, setEditCriteriaInInnerForm, setHeight, setHeight, setMaxHeight, setMinHeight, setMultiple, setOverflow, setPrompt, setShouldDisableCanvasCustomizer, setupCanvasConstructor, storeValue, storeValue, storeValue, updateCanvasTabPosition`

    - ### Methods inherited from class com.smartgwt.client.widgets.form.fields.FormItem

      `_getValue, addBlurHandler, addChangedHandler, addChangeHandler, addClickHandler, addDoubleClickHandler, addEditorEnterHandler, addEditorExitHandler, addFocusHandler, addIcon, addIcon, addIconClickHandler, addIconKeyPressHandler, addItemHoverHandler, addKeyDownHandler, addKeyPressHandler, addKeyUpHandler, addPendingStatusChangedHandler, addPickerIconClickHandler, addShowContextMenuHandler, addTitleClickHandler, addTitleDoubleClickHandler, addTitleHoverHandler, addValueHoverHandler, addValueIconClickHandler, applyFormula, asSGWTComponent, blurItem, canEditCriterion, clearErrors, clearValue, disable, disableIcon, enable, enableIcon, error, error, errorIfNotCreated, focusAfterItem, focusInItem, getAccessKey, getAlign, getAllowExpressions, getAlwaysFetchMissingValues, getAlwaysShowControlBox, getApplyAlignToText, getApplyHeightToTextBox, getAriaRole, getAttribute, getAttributeAsBoolean, getAttributeAsBoolean, getAttributeAsDate, getAttributeAsDouble, getAttributeAsFloat, getAttributeAsInt, getAttributeAsJavaScriptObject, getAttributeAsObject, getAttributeAsString, getAutoComplete, getAutoCompleteKeywords, getBrowserInputType, getBrowserSpellCheck, getCanEdit, getCanEditOpaqueValues, getCanFocus, getCanSelectText, getCanTabToIcons, getCanvasAutoChild, getCellHeight, getCellStyle, getChangeOnKeypress, getClassName, getClipStaticValue, getClipTitle, getConfig, getContainerWidget, getControlStyle, getCriteriaField, getCriterion, getCriterion, getCursorPosition, getCustomState, getDataPath, getDateFormatter, getDecimalPad, getDecimalPrecision, getDefaultIconSrc, getDisabled, getDisableIconsOnReadOnly, getDisplayField, getDisplayFieldName, getDisplayValue, getDisplayValue, getEditorTypeConfig, getEditPendingCSSText, getEditProxyConstructor, getEmptyDisplayValue, getEmptyValueIcon, getEndRow, getErrorIconHeight, getErrorIconSrc, getErrorIconWidth, getErrorMessageWidth, getErrors, getExportFormat, getFetchMissingValues, getFieldName, getFilterLocally, getForeignDisplayField, getForm, getFormat, getFormItemAutoChild, getFormula, getFullDataPath, getGlobalTabIndex, getGridColNum, getGridRowNum, getHidden, getHint, getHintStyle, getHoverAlign, getHoverDelay, getHoverHeight, getHoverOpacity, getHoverStyle, getHoverVAlign, getHoverWidth, getIcon, getIconHeight, getIconHSpace, getIconPageRect, getIconPrompt, getIconRect, getIcons, getIconTabPosition, getIconVAlign, getIconWidth, getID, getImageURLPrefix, getImageURLSuffix, getImplicitSave, getImplicitSaveOnBlur, getLeft, getListGrid, getLoadingDisplayValue, getLocateItemBy, getMinHintWidth, getMultipleValueSeparator, getName, getOptionCriteria, getOptionDataSource, getOptionDataSourceAsString, getOptionFilterContext, getOptionOperationId, getOriginalValueMessage, getPageLeft, getPageRect, getPageTop, getPaletteDefaults, getPicker, getPickerIcon, getPickerIcon, getPickerIconHeight, getPickerIconName, getPickerIconProperties, getPickerIconSrc, getPickerIconStyle, getPickerIconTabPosition, getPickerIconWidth, getPixelHeight, getPixelWidth, getPrintTextBoxStyle, getPrintTitleStyle, getReadOnlyDisplay, getReadOnlyHover, getReadOnlyTextBoxStyle, getReadOnlyWhen, getRect, getRedrawOnChange, getRejectInvalidValueOnChange, getRequired, getRequiredMessage, getRequiredWhen, getRowSpan, getSaveOnEnter, getScClassName, getSelectedRecord, getSelectOnClick, getSelectOnFocus, getShowClippedTitleOnHover, getShowClippedValueOnHover, getShowDeletions, getShowDisabled, getShowDisabledIconsOnFocus, getShowDisabledPickerIconOnFocus, getShowErrorIcon, getShowErrorStyle, getShowErrorText, getShowFocused, getShowFocusedErrorState, getShowFocusedIcons, getShowFocusedPickerIcon, getShowHint, getShowIcons, getShowIconsOnFocus, getShowOldValueInHover, getShowOver, getShowOverIcons, getShowPending, getShowPickerIcon, getShowPickerIconOnFocus, getShowRTL, getShowTitle, getShowValueIconOnly, getStartRow, getStaticHeight, getStopOnError, getSupportsCutPasteEvents, getSuppressValueIcon, getSynchronousValidation, getTabIndex, getTextAlign, getTextBoxStyle, getTextFormula, getTimeFormatter, getTitle, getTitleAlign, getTitleColSpan, getTitleOrientation, getTitleStyle, getTitleVAlign, getTooltip, getTop, getType, getUpdateControlOnOver, getUpdatePickerIconOnOver, getUpdateTextBoxOnOver, getUseAdvancedCriteria, getUseDisabledHintStyleForReadOnly, getUseLocalDisplayFieldValue, getValidateOnChange, getValidateOnExit, getValidOperators, getVAlign, getValue, getValueAsRecordList, getValueDeselectedCSSText, getValueField, getValueFieldName, getValueIconHeight, getValueIconLeftPadding, getValueIconRightPadding, getValueIconSize, getValueIconWidth, getValueMap, getValueMapAsArray, getVisible, getVisibleHeight, getVisibleTitleWidth, getVisibleWhen, getVisibleWidth, getWarnOnEditorTypeConversion, getWarnOnEditorTypeConversionDefault, getWidth, getWidthAsString, getWrapHintText, getWrapTitle, handleWarnOnEditorTypeConversion, hasErrors, hide, hideIcon, invalidateDisplayValueCache, isConfigOnly, isCreated, isCutEvent, isDisabled, isDrawn, isInGrid, isPasteEvent, isVisible, linkToInstanceUponCreate, mapDisplayToValue, mapValueToDisplay, mapValueToDisplay, mapValueToDisplay, redraw, redraw, removeIcon, setAccessKey, setAlign, setAllowExpressions, setAlwaysFetchMissingValues, setAlwaysShowControlBox, setApplyAlignToText, setApplyHeightToTextBox, setAriaRole, setAriaState, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAutoChildConstructor, setAutoChildProperties, setAutoChildProperties, setAutoChildProperties, setAutoChildVisibility, setAutoComplete, setAutoCompleteKeywords, setBrowserInputType, setBrowserSpellCheck, setCanEdit, setCanEditOpaqueValues, setCanFocus, setCanSelectText, setCanTabToIcons, setCellHeight, setCellStyle, setChangeOnKeypress, setClipStaticValue, setClipTitle, setColSpan, setColSpan, setConfigOnly, setControlStyle, setCriteriaField, setCriterion, setCustomStateGetter, setDataPath, setDecimalPad, setDecimalPrecision, setDefaultIconSrc, setDefaultProperties, setDefaultValue, setDefaultValue, setDefaultValue, setDefaultValue, setDefaultValue, setDefaultValue, setDefaultValue, setDisabled, setDisableIconsOnReadOnly, setDisplayField, setDisplayFormat, setDisplayFormat, setEditorProperties, setEditorType, setEditorType, setEditorType, setEditPendingCSSText, setEditProxyConstructor, setEmptyDisplayValue, setEmptyValueIcon, setEndRow, setErrorFormatter, setErrorIconHeight, setErrorIconSrc, setErrorIconWidth, setErrorMessageWidth, setErrorOrientation, setErrors, setErrors, setExportFormat, setFetchMissingValues, setFilterLocally, setForeignDisplayField, setFormat, setFormula, setGlobalTabIndex, setHidden, setHint, setHintStyle, setHoverAlign, setHoverDelay, setHoverHeight, setHoverOpacity, setHoverStyle, setHoverVAlign, setHoverWidth, setIconDisabled, setIconHeight, setIconHSpace, setIconPrompt, setIcons, setIconShowOnFocus, setIconVAlign, setIconWidth, setID, setImageURLPrefix, setImageURLSuffix, setImplicitSave, setImplicitSaveOnBlur, setInitHandler, setInputTransformer, setItemHoverFormatter, setItemTitleHoverFormatter, setItemValueHoverFormatter, setJavaScriptObject, setLeft, setLoadingDisplayValue, setLocateItemBy, setMinHintWidth, setMultipleValueSeparator, setName, setNullProperty, setOptionCriteria, setOptionDataSource, setOptionDataSource, setOptionFilterContext, setOptionOperationId, setOriginalValueMessage, setPickerIconHeight, setPickerIconName, setPickerIconProperties, setPickerIconSrc, setPickerIconStyle, setPickerIconWidth, setPrintTextBoxStyle, setPrintTitleStyle, setProperty, setProperty, setProperty, setProperty, setProperty, setReadOnlyDisplay, setReadOnlyHover, setReadOnlyTextBoxStyle, setReadOnlyWhen, setRedrawOnChange, setRejectInvalidValueOnChange, setRequired, setRequiredMessage, setRequiredWhen, setRowSpan, setSaveOnEnter, setScClassName, setSelectOnClick, setSelectOnFocus, setShowClippedTitleOnHover, setShowClippedValueOnHover, setShowDeletions, setShowDisabled, setShowDisabledIconsOnFocus, setShowDisabledPickerIconOnFocus, setShowErrorIcon, setShowErrorStyle, setShowErrorText, setShowFocused, setShowFocusedErrorState, setShowFocusedIcons, setShowFocusedPickerIcon, setShowHint, setShowIcons, setShowIconsOnFocus, setShowIfCondition, setShowOldValueInHover, setShowOver, setShowOverIcons, setShowPending, setShowPickerIcon, setShowPickerIconOnFocus, setShowRTL, setShowTitle, setShowValueIconOnly, setStartRow, setStateCustomizer, setStaticHeight, setStopOnError, setSupportsCutPasteEvents, setSuppressValueIcon, setSynchronousValidation, setTabIndex, setTextAlign, setTextBoxStyle, setTextFormula, setTimeFormatter, setTitle, setTitleAlign, setTitleColSpan, setTitleHoverFormatter, setTitleOrientation, setTitleStyle, setTitleVAlign, setTooltip, setTop, setType, setUpdateControlOnOver, setUpdatePickerIconOnOver, setUpdateTextBoxOnOver, setUseAdvancedCriteria, setUseDisabledHintStyleForReadOnly, setUseLocalDisplayFieldValue, setValidateOnChange, setValidateOnExit, setValidators, setValidOperators, setVAlign, setValue, setValue, setValue, setValue, setValue, setValue, setValueDeselectedCSSText, setValueField, setValueFormatter, setValueHoverFormatter, setValueIconHeight, setValueIconLeftPadding, setValueIconMapper, setValueIconRightPadding, setValueIcons, setValueIconSize, setValueIconWidth, setValueMap, setValueMap, setVisible, setVisibleWhen, setWarnOnEditorTypeConversion, setWarnOnEditorTypeConversionDefault, setWidth, setWidth, setWrapHintText, setWrapTitle, shouldApplyHeightToTextBox, shouldFetchMissingValue, shouldSaveOnEnter, shouldStopKeyPressBubbling, show, showIcon, showPicker, stopHover, storeValue, updateState, validate, valueClipped`

    - ### Methods inherited from class com.smartgwt.client.core.RefDataClass

      `getRef, getRef, internalSetID`

    - ### Methods inherited from class com.smartgwt.client.core.DataClass

      `applyFactoryProperties, doAddHandler, fireEvent, getAttributeAsDoubleArray, getAttributeAsIntArray, getAttributeAsLong, getAttributeAsMap, getAttributeAsObject, getAttributeAsRecord, getAttributeAsStringArray, getAttributes, getHandlerCount, isFactoryCreated, setAttribute, setAttribute, setAttribute, setAttributeAsJavaObject, setFactoryCreated`

    - ### Methods inherited from class com.smartgwt.client.core.JsObject

      `equals, getJsObj, hashCode, setJsObj`

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface com.google.gwt.event.shared.HasHandlers

      `fireEvent`

- - ### Constructor Detail

    - #### RelativeDateItem

          public RelativeDateItem()

    - #### RelativeDateItem

          public RelativeDateItem(com.google.gwt.core.client.JavaScriptObject jsObj)

    - #### RelativeDateItem

          public RelativeDateItem(java.lang.String name)

    - #### RelativeDateItem

          public RelativeDateItem(java.lang.String name,
                                  java.lang.String title)

  - ### Method Detail

    - #### getOrCreateRef

          public static RelativeDateItem getOrCreateRef(com.google.gwt.core.client.JavaScriptObject jsObj)

    - #### changeAutoChildDefaults

          public static void changeAutoChildDefaults(java.lang.String autoChildName,
                                                     Canvas defaults)

      Changes the defaults for Canvas AutoChildren named `autoChildName`.
      Parameters:
        `autoChildName` - name of an AutoChild to customize the defaults for.
        `defaults` - Canvas defaults to apply. These defaults override any existing properties without destroying or wiping out non-overridden properties. For usage tips on this param, see `SGWTProperties`.
      See Also:
        `AutoChildUsage`

    - #### changeAutoChildDefaults

          public static void changeAutoChildDefaults(java.lang.String autoChildName,
                                                     FormItem defaults)

      Changes the defaults for FormItem AutoChildren named `autoChildName`.
      Parameters:
        `autoChildName` - name of an AutoChild to customize the defaults for.
        `defaults` - FormItem defaults to apply. These defaults override any existing properties without destroying or wiping out non-overridden properties. For usage tips on this param, see `SGWTProperties`.
      See Also:
        `AutoChildUsage`

    - #### changePickerIconDefaults

          public static void changePickerIconDefaults(FormItemIcon defaults)

    - #### setAllowAbsoluteDates

          public void setAllowAbsoluteDates(java.lang.Boolean allowAbsoluteDates)

      When set to false, only relative dates can be entered - in this mode, the `date chooser icon` is hidden and the `value field` is switched from a `ComboBoxItem`, which allows text-entry, to a `SelectItem` which does not.
      Parameters:
        `allowAbsoluteDates` - New allowAbsoluteDates value. Default value is true

    - #### getAllowAbsoluteDates

          public java.lang.Boolean getAllowAbsoluteDates()

      When set to false, only relative dates can be entered - in this mode, the `date chooser icon` is hidden and the `value field` is switched from a `ComboBoxItem`, which allows text-entry, to a `SelectItem` which does not.
      Returns:
        Current allowAbsoluteDates value. Default value is true

    - #### setBaseDate

          public void setBaseDate(java.util.Date baseDate)

      Base date for calculating the relative date entered by the user.

      The default is to use the current date.

      Parameters:
        `baseDate` - New baseDate value. Default value is null

    - #### getBaseDate

          public java.util.Date getBaseDate()

      Base date for calculating the relative date entered by the user.

      The default is to use the current date.

      Returns:
        Current baseDate value. Default value is null

    - #### getCalculatedDateField

          public BlurbItem getCalculatedDateField()

      Field that shows the current calculated date by adding the user-entered relative date to the `baseDate`.

      This component is an AutoChild named "calculatedDateField". For an overview of how to use and configure AutoChildren, see `Using AutoChildren`.

      Returns:
        Current calculatedDateField value. Default value is null

    - #### setCenturyThreshold

          public void setCenturyThreshold(int centuryThreshold)

      Only used if we're showing the date in a text field. When parsing a date, if the year is specified with 1 or 2 digits and is less than the centuryThreshold, then the year will be assumed to be 20xx; otherwise it will be interpreted according to default browser behaviour, which will consider it to be 19xx.

      If you need to allow 1 and 2 digit years, set this attribute to `null` to have the control retain your year-value as entered.

      Parameters:
        `centuryThreshold` - New centuryThreshold value. Default value is 25
      See Also:
        `Appearance overview and related methods`

    - #### getCenturyThreshold

          public int getCenturyThreshold()

      Only used if we're showing the date in a text field. When parsing a date, if the year is specified with 1 or 2 digits and is less than the centuryThreshold, then the year will be assumed to be 20xx; otherwise it will be interpreted according to default browser behaviour, which will consider it to be 19xx.

      If you need to allow 1 and 2 digit years, set this attribute to `null` to have the control retain your year-value as entered.

      Returns:
        Current centuryThreshold value. Default value is 25
      See Also:
        `Appearance overview and related methods`

    - #### setDaysAgoTitle

          public void setDaysAgoTitle(java.lang.String daysAgoTitle)

      The title to show for historical periods when the `TimeUnit` is "day".
      Parameters:
        `daysAgoTitle` - New daysAgoTitle value. Default value is "N days ago"

    - #### getDaysAgoTitle

          public java.lang.String getDaysAgoTitle()

      The title to show for historical periods when the `TimeUnit` is "day".
      Returns:
        Current daysAgoTitle value. Default value is "N days ago"

    - #### setDaysFromNowTitle

          public void setDaysFromNowTitle(java.lang.String daysFromNowTitle)

      The title to show for future periods when the `TimeUnit` is "day".
      Parameters:
        `daysFromNowTitle` - New daysFromNowTitle value. Default value is "N days from now"

    - #### getDaysFromNowTitle

          public java.lang.String getDaysFromNowTitle()

      The title to show for future periods when the `TimeUnit` is "day".
      Returns:
        Current daysFromNowTitle value. Default value is "N days from now"

    - #### setDefaultQuantity

          public void setDefaultQuantity(int defaultQuantity)

      Default quantity to show in the `quantityField`.
      Parameters:
        `defaultQuantity` - New defaultQuantity value. Default value is 1

    - #### getDefaultQuantity

          public int getDefaultQuantity()

      Default quantity to show in the `quantityField`.
      Returns:
        Current defaultQuantity value. Default value is 1

    - #### setEndDate

          public void setEndDate(java.util.Date endDate)

      Maximum date the selectors will allow the user to pick. The default value is December 31st, 5 years after the current year.

      See `DateItem.startDate` for details on how this restriction works.

      Parameters:
        `endDate` - New endDate value. Default value is 12/31/2020
      See Also:
        `Appearance overview and related methods`

    - #### getEndDate

          public java.util.Date getEndDate()

      Maximum date the selectors will allow the user to pick. The default value is December 31st, 5 years after the current year.

      See `DateItem.startDate` for details on how this restriction works.

      Returns:
        Current endDate value. Default value is 12/31/2020
      See Also:
        `Appearance overview and related methods`

    - #### setHoursAgoTitle

          public void setHoursAgoTitle(java.lang.String hoursAgoTitle)

      The title to show for historical periods when the `TimeUnit` is "hour".
      Parameters:
        `hoursAgoTitle` - New hoursAgoTitle value. Default value is "N hours ago"

    - #### getHoursAgoTitle

          public java.lang.String getHoursAgoTitle()

      The title to show for historical periods when the `TimeUnit` is "hour".
      Returns:
        Current hoursAgoTitle value. Default value is "N hours ago"

    - #### setHoursFromNowTitle

          public void setHoursFromNowTitle(java.lang.String hoursFromNowTitle)

      The title to show for future periods when the `TimeUnit` is "hour".
      Parameters:
        `hoursFromNowTitle` - New hoursFromNowTitle value. Default value is "N hours from now"

    - #### getHoursFromNowTitle

          public java.lang.String getHoursFromNowTitle()

      The title to show for future periods when the `TimeUnit` is "hour".
      Returns:
        Current hoursFromNowTitle value. Default value is "N hours from now"

    - #### setInputFormat

          public void setInputFormat(java.lang.String inputFormat)

      Format for direct user input of date values.

      If unset, the input format will be determined based on the specified `displayFormat` if possible, otherwise picked up from the Date class (see `DateUtil.setInputFormat()`).

      Overrides:
        `setInputFormat` in class `FormItem`
      Parameters:
        `inputFormat` - New inputFormat value. Default value is null
      See Also:
        `DateInputFormat`

    - #### getInputFormat

          public java.lang.String getInputFormat()

      Format for direct user input of date values.

      If unset, the input format will be determined based on the specified `displayFormat` if possible, otherwise picked up from the Date class (see `DateUtil.setInputFormat()`).

      Overrides:
        `getInputFormat` in class `FormItem`
      Returns:
        If `DateItem.useTextField` is `true` this method returns a standard `DateInputFormat`, determining how values entered by the user are to be converted to Javascript Date objects.

        If an explicit `DateItem.inputFormat` has been specified it will be returned, otherwise, if a custom `DateItem.dateFormatter` or `FormItem.format` are specified, the input format will be automatically derived from that property.

        Otherwise, the global `inputFormat` is used.

        Note that the inputFormat will ignore any separator characters and padding of values. However if necessary entirely custom date formatting and parsing may be achieved via the `setEditorValueFormatter()` and `setEditorValueParser()` APIs. Default value is null

      See Also:
        `DateInputFormat`

    - #### setMaxQuantity

          public void setMaxQuantity(int maxQuantity)

      Maximum value to allow in the `quantityField`. Increasing this value may result in date miscalculations for very large numbers, due to Javascript Date limitations.
      Parameters:
        `maxQuantity` - New maxQuantity value. Default value is 999999

    - #### getMaxQuantity

          public int getMaxQuantity()

      Maximum value to allow in the `quantityField`. Increasing this value may result in date miscalculations for very large numbers, due to Javascript Date limitations.
      Returns:
        Current maxQuantity value. Default value is 999999

    - #### setMillisecondsAgoTitle

          public void setMillisecondsAgoTitle(java.lang.String millisecondsAgoTitle)

      The title to show for historical periods when the `TimeUnit` is "millisecond".
      Parameters:
        `millisecondsAgoTitle` - New millisecondsAgoTitle value. Default value is "N milliseconds ago"

    - #### getMillisecondsAgoTitle

          public java.lang.String getMillisecondsAgoTitle()

      The title to show for historical periods when the `TimeUnit` is "millisecond".
      Returns:
        Current millisecondsAgoTitle value. Default value is "N milliseconds ago"

    - #### setMillisecondsFromNowTitle

          public void setMillisecondsFromNowTitle(java.lang.String millisecondsFromNowTitle)

      The title to show for future periods when the `TimeUnit` is "millisecond".
      Parameters:
        `millisecondsFromNowTitle` - New millisecondsFromNowTitle value. Default value is "N milliseconds from now"

    - #### getMillisecondsFromNowTitle

          public java.lang.String getMillisecondsFromNowTitle()

      The title to show for future periods when the `TimeUnit` is "millisecond".
      Returns:
        Current millisecondsFromNowTitle value. Default value is "N milliseconds from now"

    - #### setMinQuantity

          public void setMinQuantity(int minQuantity)

      Minimum value to allow in the `quantityField`.
      Parameters:
        `minQuantity` - New minQuantity value. Default value is 0

    - #### getMinQuantity

          public int getMinQuantity()

      Minimum value to allow in the `quantityField`.
      Returns:
        Current minQuantity value. Default value is 0

    - #### setMinutesAgoTitle

          public void setMinutesAgoTitle(java.lang.String minutesAgoTitle)

      The title to show for historical periods when the `TimeUnit` is "minute".
      Parameters:
        `minutesAgoTitle` - New minutesAgoTitle value. Default value is "N minutes ago"

    - #### getMinutesAgoTitle

          public java.lang.String getMinutesAgoTitle()

      The title to show for historical periods when the `TimeUnit` is "minute".
      Returns:
        Current minutesAgoTitle value. Default value is "N minutes ago"

    - #### setMinutesFromNowTitle

          public void setMinutesFromNowTitle(java.lang.String minutesFromNowTitle)

      The title to show for future periods when the `TimeUnit` is "minute".
      Parameters:
        `minutesFromNowTitle` - New minutesFromNowTitle value. Default value is "N minutes from now"

    - #### getMinutesFromNowTitle

          public java.lang.String getMinutesFromNowTitle()

      The title to show for future periods when the `TimeUnit` is "minute".
      Returns:
        Current minutesFromNowTitle value. Default value is "N minutes from now"

    - #### setMonthsAgoTitle

          public void setMonthsAgoTitle(java.lang.String monthsAgoTitle)

      The title to show for historical periods when the `TimeUnit` is "month".
      Parameters:
        `monthsAgoTitle` - New monthsAgoTitle value. Default value is "N months ago"

    - #### getMonthsAgoTitle

          public java.lang.String getMonthsAgoTitle()

      The title to show for historical periods when the `TimeUnit` is "month".
      Returns:
        Current monthsAgoTitle value. Default value is "N months ago"

    - #### setMonthsFromNowTitle

          public void setMonthsFromNowTitle(java.lang.String monthsFromNowTitle)

      The title to show for future periods when the `TimeUnit` is "month".
      Parameters:
        `monthsFromNowTitle` - New monthsFromNowTitle value. Default value is "N months from now"

    - #### getMonthsFromNowTitle

          public java.lang.String getMonthsFromNowTitle()

      The title to show for future periods when the `TimeUnit` is "month".
      Returns:
        Current monthsFromNowTitle value. Default value is "N months from now"

    - #### setOperator

          public void setOperator(OperatorId operator)

      What operator to use when the `FormItemCriterionGetter`'s `getCriterion()` method is called.
      Overrides:
        `setOperator` in class `FormItem`
      Parameters:
        `operator` - New operator value. Default value is "greaterThan"
      See Also:
        `CriteriaEditing overview and related methods`

    - #### getOperator

          public OperatorId getOperator()

      What operator to use when the `FormItemCriterionGetter`'s `getCriterion()` method is called.
      Overrides:
        `getOperator` in class `FormItem`
      Returns:
        Current operator value. Default value is "greaterThan"
      See Also:
        `CriteriaEditing overview and related methods`

    - #### setPickerConstructor

          public void setPickerConstructor(java.lang.String pickerConstructor)

      Smart GWT class for the `dateChooser` autoChild displayed to allow the user to directly select dates.
      Parameters:
        `pickerConstructor` - New pickerConstructor value. Default value is "DateChooser"

    - #### getPickerConstructor

          public java.lang.String getPickerConstructor()

      Smart GWT class for the `dateChooser` autoChild displayed to allow the user to directly select dates.
      Returns:
        Current pickerConstructor value. Default value is "DateChooser"

    - #### getPickerIcon

          public FormItemIcon getPickerIcon()

      Icon that launches a `DateChooser` for choosing an absolute date.

      This component is an AutoChild named "pickerIcon". For an overview of how to use and configure AutoChildren, see `Using AutoChildren`.

      Returns:
        Current pickerIcon value. Default value is null

    - #### setPickerIconPrompt

          public void setPickerIconPrompt(java.lang.String pickerIconPrompt)

      Prompt to show when the user hovers the mouse over the picker icon for this RelativeDateItem. May be overridden for localization of your application.
      Overrides:
        `setPickerIconPrompt` in class `FormItem`
      Parameters:
        `pickerIconPrompt` - New pickerIconPrompt value. Default value is "Show Date Chooser"
      See Also:
        `HTMLString`

    - #### getPickerIconPrompt

          public java.lang.String getPickerIconPrompt()

      Prompt to show when the user hovers the mouse over the picker icon for this RelativeDateItem. May be overridden for localization of your application.
      Overrides:
        `getPickerIconPrompt` in class `FormItem`
      Returns:
        Current pickerIconPrompt value. Default value is "Show Date Chooser"
      See Also:
        `HTMLString`

    - #### setPickerTimeItemProperties

          public void setPickerTimeItemProperties(TimeItem pickerTimeItemProperties)

      A set of properties to apply to the `TimeItem` displayed in the picker when `showPickerTimeItem` is true.

      Has no effect for fields of type `"date"`.

      Note : This is an advanced setting

      Parameters:
        `pickerTimeItemProperties` - New pickerTimeItemProperties value. Default value is null

    - #### getPickerTimeItemProperties

          public TimeItem getPickerTimeItemProperties()

      A set of properties to apply to the `TimeItem` displayed in the picker when `showPickerTimeItem` is true.

      Has no effect for fields of type `"date"`.

      Returns:
        Current pickerTimeItemProperties value. Default value is null

    - #### getQuantityField

          public SpinnerItem getQuantityField()

      Field allowing user to pick units of time, eg, number of days.

      This component is an AutoChild named "quantityField". For an overview of how to use and configure AutoChildren, see `Using AutoChildren`.

      Returns:
        Current quantityField value. Default value is null

    - #### setQuartersAgoTitle

          public void setQuartersAgoTitle(java.lang.String quartersAgoTitle)

      The title to show for historical periods when the `TimeUnit` is "quarter".
      Parameters:
        `quartersAgoTitle` - New quartersAgoTitle value. Default value is "N quarters ago"

    - #### getQuartersAgoTitle

          public java.lang.String getQuartersAgoTitle()

      The title to show for historical periods when the `TimeUnit` is "quarter".
      Returns:
        Current quartersAgoTitle value. Default value is "N quarters ago"

    - #### setQuartersFromNowTitle

          public void setQuartersFromNowTitle(java.lang.String quartersFromNowTitle)

      The title to show for future periods when the `TimeUnit` is "quarter".
      Parameters:
        `quartersFromNowTitle` - New quartersFromNowTitle value. Default value is "N quarters from now"

    - #### getQuartersFromNowTitle

          public java.lang.String getQuartersFromNowTitle()

      The title to show for future periods when the `TimeUnit` is "quarter".
      Returns:
        Current quartersFromNowTitle value. Default value is "N quarters from now"

    - #### setRangePosition

          public void setRangePosition(RelativeDateRangePosition rangePosition)

      Does this items relative date value refer to the start or end of the chosen date? Useful when using this item to generate filter criteria, such as the from or to value for an inclusive range.

      If unset "start" is assumed.

      Note : This is an advanced setting

      Parameters:
        `rangePosition` - New rangePosition value. Default value is null
      See Also:
        `setOperator(com.smartgwt.client.types.OperatorId)`, `setRangeRoundingGranularity(java.util.Map)`

    - #### getRangePosition

          public RelativeDateRangePosition getRangePosition()

      Does this items relative date value refer to the start or end of the chosen date? Useful when using this item to generate filter criteria, such as the from or to value for an inclusive range.

      If unset "start" is assumed.

      Returns:
        Current rangePosition value. Default value is null
      See Also:
        `getOperator()`, `com.smartgwt.client.widgets.form.fields.RelativeDateItem#getRangeRoundingGranularity`

    - #### setSecondsAgoTitle

          public void setSecondsAgoTitle(java.lang.String secondsAgoTitle)

      The title to show for historical periods when the `TimeUnit` is "second".
      Parameters:
        `secondsAgoTitle` - New secondsAgoTitle value. Default value is "N seconds ago"

    - #### getSecondsAgoTitle

          public java.lang.String getSecondsAgoTitle()

      The title to show for historical periods when the `TimeUnit` is "second".
      Returns:
        Current secondsAgoTitle value. Default value is "N seconds ago"

    - #### setSecondsFromNowTitle

          public void setSecondsFromNowTitle(java.lang.String secondsFromNowTitle)

      The title to show for future periods when the `TimeUnit` is "second".
      Parameters:
        `secondsFromNowTitle` - New secondsFromNowTitle value. Default value is "N seconds from now"

    - #### getSecondsFromNowTitle

          public java.lang.String getSecondsFromNowTitle()

      The title to show for future periods when the `TimeUnit` is "second".
      Returns:
        Current secondsFromNowTitle value. Default value is "N seconds from now"

    - #### setShouldSaveValue

          public void setShouldSaveValue(java.lang.Boolean shouldSaveValue)

      Should this item's value be saved in the form's values and hence returned from `form.getValues()`?

      `shouldSaveValue:false` is used to mark formItems which do not correspond to the underlying data model and should not save a value into the form's `values`. Example includes visual separators, password re-type fields, or checkboxes used to show/hide other form items.

      A `shouldSaveValue:false` item should be given a value either via `FormItem.defaultValue` or by calling `form.setValue(item, value)` or `formItem.setValue(value)`. Providing a value via `form.values` or `form.setValues()` will automatically switch the item to `shouldSaveValue:true`.

      Note that

      - if an item is shouldSaveValue true, but has no name, a warning is logged, and shouldSaveValue will be set to false.
      Overrides:
        `setShouldSaveValue` in class `CanvasItem`
      Parameters:
        `shouldSaveValue` - New shouldSaveValue value. Default value is true

    - #### getShouldSaveValue

          public java.lang.Boolean getShouldSaveValue()

      Should this item's value be saved in the form's values and hence returned from `form.getValues()`?

      `shouldSaveValue:false` is used to mark formItems which do not correspond to the underlying data model and should not save a value into the form's `values`. Example includes visual separators, password re-type fields, or checkboxes used to show/hide other form items.

      A `shouldSaveValue:false` item should be given a value either via `FormItem.defaultValue` or by calling `form.setValue(item, value)` or `formItem.setValue(value)`. Providing a value via `form.values` or `form.setValues()` will automatically switch the item to `shouldSaveValue:true`.

      Note that

      - if an item is shouldSaveValue true, but has no name, a warning is logged, and shouldSaveValue will be set to false.
      Overrides:
        `getShouldSaveValue` in class `CanvasItem`
      Returns:
        Current shouldSaveValue value. Default value is true

    - #### setShowCalculatedDateField

          public void setShowCalculatedDateField(java.lang.Boolean showCalculatedDateField)

      Should the Calculated-Date be displayed to the right of the `pickerIcon`.
      Parameters:
        `showCalculatedDateField` - New showCalculatedDateField value. Default value is true

    - #### getShowCalculatedDateField

          public java.lang.Boolean getShowCalculatedDateField()

      Should the Calculated-Date be displayed to the right of the `pickerIcon`.
      Returns:
        Current showCalculatedDateField value. Default value is true

    - #### setShowChooserFiscalYearPicker

          public void setShowChooserFiscalYearPicker(java.lang.Boolean showChooserFiscalYearPicker)

      When set to true, show a button that allows the calendar to be navigated by fiscal year.
      Parameters:
        `showChooserFiscalYearPicker` - New showChooserFiscalYearPicker value. Default value is false

    - #### getShowChooserFiscalYearPicker

          public java.lang.Boolean getShowChooserFiscalYearPicker()

      When set to true, show a button that allows the calendar to be navigated by fiscal year.
      Returns:
        Current showChooserFiscalYearPicker value. Default value is false

    - #### setShowChooserIcon

          public void setShowChooserIcon(java.lang.Boolean showChooserIcon)

      Should we show the icon that displays a date-chooser?
      Parameters:
        `showChooserIcon` - New showChooserIcon value. Default value is true

    - #### getShowChooserIcon

          public java.lang.Boolean getShowChooserIcon()

      Should we show the icon that displays a date-chooser?
      Returns:
        Current showChooserIcon value. Default value is true

    - #### setShowChooserWeekPicker

          public void setShowChooserWeekPicker(java.lang.Boolean showChooserWeekPicker)

      When set to true, show a button that allows the calendar to be navigated by week or fiscal week, depending on the value of `showChooserFiscalYearPicker`.
      Parameters:
        `showChooserWeekPicker` - New showChooserWeekPicker value. Default value is false

    - #### getShowChooserWeekPicker

          public java.lang.Boolean getShowChooserWeekPicker()

      When set to true, show a button that allows the calendar to be navigated by week or fiscal week, depending on the value of `showChooserFiscalYearPicker`.
      Returns:
        Current showChooserWeekPicker value. Default value is false

    - #### setShowFutureOptions

          public void setShowFutureOptions(java.lang.Boolean showFutureOptions)

      Should we show time-unit options in the future? If set to false, for each `timeUnitOption` we will show only past options [for example "N weeks ago"].

      Note: this does not change the `presetOptions`, which show up in addition to the time-unit options ("N days from now", etc). The default preset options include both past and future presets so developers may wish to modify the presets to ensure only future options are available.

      Parameters:
        `showFutureOptions` - New showFutureOptions value. Default value is true

    - #### getShowFutureOptions

          public java.lang.Boolean getShowFutureOptions()

      Should we show time-unit options in the future? If set to false, for each `timeUnitOption` we will show only past options [for example "N weeks ago"].

      Note: this does not change the `presetOptions`, which show up in addition to the time-unit options ("N days from now", etc). The default preset options include both past and future presets so developers may wish to modify the presets to ensure only future options are available.

      Returns:
        Current showFutureOptions value. Default value is true

    - #### setShowPastOptions

          public void setShowPastOptions(java.lang.Boolean showPastOptions)

      Should we show time-unit options in the past? If set to false, for each `timeUnitOption` we will show only future options [for example "N weeks from now"].

      Note: this does not change the `presetOptions`, which show up in addition to the time-unit options ("N days from now", etc). The default preset options include both past and future presets so developers may wish to modify the presets to ensure only past options are available.

      Parameters:
        `showPastOptions` - New showPastOptions value. Default value is true

    - #### getShowPastOptions

          public java.lang.Boolean getShowPastOptions()

      Should we show time-unit options in the past? If set to false, for each `timeUnitOption` we will show only future options [for example "N weeks from now"].

      Note: this does not change the `presetOptions`, which show up in addition to the time-unit options ("N days from now", etc). The default preset options include both past and future presets so developers may wish to modify the presets to ensure only past options are available.

      Returns:
        Current showPastOptions value. Default value is true

    - #### setShowPickerTimeItem

          public void setShowPickerTimeItem(java.lang.Boolean showPickerTimeItem)

      If this item is editing a field of type `"datetime"`, should the `DateChooser` display the `time field`, allowing the user to select a time?

      One case where developers will wish to suppress this time-field from being displayed is if a custom `dateFormatter` has been specified which does not display the time portion of the selected date. In this case any value selected from the DateChooser's time field will be discarded when the picker is dismissed, making it a confusing UI for the end user.

      Has no effect if the field type is `"date"` - in this case the picker will never show the time field.

      Note : This is an advanced setting

      Parameters:
        `showPickerTimeItem` - New showPickerTimeItem value. Default value is true

    - #### getShowPickerTimeItem

          public java.lang.Boolean getShowPickerTimeItem()

      If this item is editing a field of type `"datetime"`, should the `DateChooser` display the `time field`, allowing the user to select a time?

      One case where developers will wish to suppress this time-field from being displayed is if a custom `dateFormatter` has been specified which does not display the time portion of the selected date. In this case any value selected from the DateChooser's time field will be discarded when the picker is dismissed, making it a confusing UI for the end user.

      Has no effect if the field type is `"date"` - in this case the picker will never show the time field.

      Returns:
        Current showPickerTimeItem value. Default value is true

    - #### setStartDate

          public void setStartDate(java.util.Date startDate)

      Minimum date the selectors will allow the user to pick. The default value is January 1st, 10 years before the current year.

      NOTE: by design, setting `startDate` and `endDate` will not always prevent the user from picking invalid values. In particular:

      - the set of available days will only be restricted if the start and end dates fall within the same month
      - the set of available months will only be restricted if the start and end dates fall within the same year

      This is by design as it allows the user to set the day, month and year in whatever order is convenient, rather than forcing them to pick in a specific order.

      For actual enforcement of a date being in correct range before data is submitted, a `Validator` of type "dateRange" should always be declared.

      Parameters:
        `startDate` - New startDate value. Default value is 1/1/1995
      See Also:
        `Appearance overview and related methods`

    - #### getStartDate

          public java.util.Date getStartDate()

      Minimum date the selectors will allow the user to pick. The default value is January 1st, 10 years before the current year.

      NOTE: by design, setting `startDate` and `endDate` will not always prevent the user from picking invalid values. In particular:

      - the set of available days will only be restricted if the start and end dates fall within the same month
      - the set of available months will only be restricted if the start and end dates fall within the same year

      This is by design as it allows the user to set the day, month and year in whatever order is convenient, rather than forcing them to pick in a specific order.

      For actual enforcement of a date being in correct range before data is submitted, a `Validator` of type "dateRange" should always be declared.

      Returns:
        Current startDate value. Default value is 1/1/1995
      See Also:
        `Appearance overview and related methods`

    - #### setTimeUnitOptions

          public void setTimeUnitOptions(TimeUnit... timeUnitOptions)

      List of time units that will be offered for relative dates.

      Each available time unit option will cause two options to appear in the `valueField`. For example, if "day" is an available `time unit` option, there will be `"N days ago"` and `"N days from now"`.

      Parameters:
        `timeUnitOptions` - New timeUnitOptions value. Default value is ["day", "week", "month"]
      See Also:
        `setShowPastOptions(java.lang.Boolean)`, `setShowFutureOptions(java.lang.Boolean)`, `setRangeRoundingGranularity(java.util.Map)`

    - #### getTimeUnitOptions

          public TimeUnit[] getTimeUnitOptions()

      List of time units that will be offered for relative dates.

      Each available time unit option will cause two options to appear in the `valueField`. For example, if "day" is an available `time unit` option, there will be `"N days ago"` and `"N days from now"`.

      Returns:
        Current timeUnitOptions value. Default value is ["day", "week", "month"]
      See Also:
        `getShowPastOptions()`, `getShowFutureOptions()`, `com.smartgwt.client.widgets.form.fields.RelativeDateItem#getRangeRoundingGranularity`

    - #### setUse24HourTime

          public void setUse24HourTime(java.lang.Boolean use24HourTime)

      When showing the `DateChooser`, should the `time field` be set to use 24-hour time? Has no effect for fields of type `"date"` rather than `"datetime"`, or if `showPickerTimeItem` is `false`.

      Default is true.

      Parameters:
        `use24HourTime` - New use24HourTime value. Default value is true

    - #### getUse24HourTime

          public java.lang.Boolean getUse24HourTime()

      When showing the `DateChooser`, should the `time field` be set to use 24-hour time? Has no effect for fields of type `"date"` rather than `"datetime"`, or if `showPickerTimeItem` is `false`.

      Default is true.

      Returns:
        Current use24HourTime value. Default value is true

    - #### setUseSharedPicker

          public void setUseSharedPicker(java.lang.Boolean useSharedPicker)

      When set to true (the default), use a single shared date-picker across all widgets that use one. When false, create a new picker using the autoChild system. See `picker` and `pickerProperties` for details on setting up an unshared picker.
      Parameters:
        `useSharedPicker` - New useSharedPicker value. Default value is true

    - #### getUseSharedPicker

          public java.lang.Boolean getUseSharedPicker()

      When set to true (the default), use a single shared date-picker across all widgets that use one. When false, create a new picker using the autoChild system. See `picker` and `pickerProperties` for details on setting up an unshared picker.
      Returns:
        Current useSharedPicker value. Default value is true

    - #### setValueFieldWidth

          public void setValueFieldWidth(int valueFieldWidth)

      The `width` for the `valueField` in this item. Defaults to the current default value for the width attribute on the `DateTimeItem` class - this is assumed to be just wide enough to show a full datetime string, in the current global datetime format.

      Setting the width globally on the `DateTimeItem` class results in all text-based datetime entry fields assuming the same default width - this caters for custom date-time formatters that need differing amounts of space.

      Parameters:
        `valueFieldWidth` - New valueFieldWidth value. Default value is null

    - #### getValueFieldWidth

          public int getValueFieldWidth()

      The `width` for the `valueField` in this item. Defaults to the current default value for the width attribute on the `DateTimeItem` class - this is assumed to be just wide enough to show a full datetime string, in the current global datetime format.

      Setting the width globally on the `DateTimeItem` class results in all text-based datetime entry fields assuming the same default width - this caters for custom date-time formatters that need differing amounts of space.

      Note : This method will return -1 if the underlying SmartClient JavaScript attribute value cannot be expressed as a(n) int. In that case, other getters, similarly-named but ending in `AsString`, `AsCanvas`, etc., may be provided.

      Returns:
        Current valueFieldWidth value. Default value is null

    - #### setValueFieldWidth

          public void setValueFieldWidth(java.lang.String valueFieldWidth)

      The `width` for the `valueField` in this item. Defaults to the current default value for the width attribute on the `DateTimeItem` class - this is assumed to be just wide enough to show a full datetime string, in the current global datetime format.

      Setting the width globally on the `DateTimeItem` class results in all text-based datetime entry fields assuming the same default width - this caters for custom date-time formatters that need differing amounts of space.

      Parameters:
        `valueFieldWidth` - New valueFieldWidth value. Default value is null

    - #### getValueFieldWidthAsString

          public java.lang.String getValueFieldWidthAsString()

      The `width` for the `valueField` in this item. Defaults to the current default value for the width attribute on the `DateTimeItem` class - this is assumed to be just wide enough to show a full datetime string, in the current global datetime format.

      Setting the width globally on the `DateTimeItem` class results in all text-based datetime entry fields assuming the same default width - this caters for custom date-time formatters that need differing amounts of space.

      Returns:
        Current valueFieldWidth value. Default value is null

    - #### setWeeksAgoTitle

          public void setWeeksAgoTitle(java.lang.String weeksAgoTitle)

      The title to show for historical periods when the `TimeUnit` is "week".
      Parameters:
        `weeksAgoTitle` - New weeksAgoTitle value. Default value is "N weeks ago"

    - #### getWeeksAgoTitle

          public java.lang.String getWeeksAgoTitle()

      The title to show for historical periods when the `TimeUnit` is "week".
      Returns:
        Current weeksAgoTitle value. Default value is "N weeks ago"

    - #### setWeeksFromNowTitle

          public void setWeeksFromNowTitle(java.lang.String weeksFromNowTitle)

      The title to show for future periods when the `TimeUnit` is "week".
      Parameters:
        `weeksFromNowTitle` - New weeksFromNowTitle value. Default value is "N weeks from now"

    - #### getWeeksFromNowTitle

          public java.lang.String getWeeksFromNowTitle()

      The title to show for future periods when the `TimeUnit` is "week".
      Returns:
        Current weeksFromNowTitle value. Default value is "N weeks from now"

    - #### setYearsAgoTitle

          public void setYearsAgoTitle(java.lang.String yearsAgoTitle)

      The title to show for historical periods when the `TimeUnit` is "year".
      Parameters:
        `yearsAgoTitle` - New yearsAgoTitle value. Default value is "N years ago"

    - #### getYearsAgoTitle

          public java.lang.String getYearsAgoTitle()

      The title to show for historical periods when the `TimeUnit` is "year".
      Returns:
        Current yearsAgoTitle value. Default value is "N years ago"

    - #### setYearsFromNowTitle

          public void setYearsFromNowTitle(java.lang.String yearsFromNowTitle)

      The title to show for future periods when the `TimeUnit` is "year".
      Parameters:
        `yearsFromNowTitle` - New yearsFromNowTitle value. Default value is "N years from now"

    - #### getYearsFromNowTitle

          public java.lang.String getYearsFromNowTitle()

      The title to show for future periods when the `TimeUnit` is "year".
      Returns:
        Current yearsFromNowTitle value. Default value is "N years from now"

    - #### formatEditorValue

          public void formatEditorValue()

      RelativeDateItems do not make use of the standard `FormItem.formatEditorValue()` and `FormItem.parseEditorValue()` methods. Developers can customize the display values for these items in the following ways:
      - The `presetOptions` map allows standard preset RelativeDateString and RelativeDateShortcut values to be mapped to custom display values
      - The text displayed for each of the `timeUnitOptions` (e.g:"N days ago") may be customized via the per-time unit title attributes (`daysFromNowTitle`, `daysAgoTitle`, etc)
      - The `dateFormatter` and `inputFormat` may be used modify how date values are displayed (both in the text entry box and in the `calculatedDateField`

    - #### getEnteredValue

          public void getEnteredValue()

      Returns the raw text value typed into this items value text field

    - #### getFiscalCalendar

          public FiscalCalendar getFiscalCalendar()

      Returns the `FiscalCalendar` object that will be used by this item's DateChooser.
      Returns:
        the fiscal calendar for this chooser, if set, or the global one otherwise

    - #### parseEditorValue

          public void parseEditorValue()

      RelativeDateItems do not make use of the standard `FormItem.formatEditorValue()` and `FormItem.parseEditorValue()` methods. Developers can customize the display values for these items in the following ways:
      - The `presetOptions` map allows standard preset RelativeDateString and RelativeDateShortcut values to be mapped to custom display values
      - The text displayed for each of the `timeUnitOptions` (e.g:"N days ago") may be customized via the per-time unit title attributes (`daysFromNowTitle`, `daysAgoTitle`, etc)
      - The `dateFormatter` and `inputFormat` may be used modify how date values are displayed (both in the text entry box and in the `calculatedDateField`

    - #### setFiscalCalendar

          public void setFiscalCalendar()

      Sets the `FiscalCalendar` object that will be used by this item's DateChooser. If unset, the `global fiscal calendar` is used.

    - #### setFiscalCalendar

          public void setFiscalCalendar(FiscalCalendar fiscalCalendar)

      Sets the `FiscalCalendar` object that will be used by this item's DateChooser. If unset, the `global fiscal calendar` is used.
      Parameters:
        `fiscalCalendar` - the fiscal calendar for this chooser, if set, or the global one otherwise

    - #### setDefaultProperties

          public static void setDefaultProperties(RelativeDateItem relativeDateItemProperties)

      Class level method to set the default properties of this class. If set, then all existing and subsequently created instances of this class will automatically have default properties corresponding to the properties of the class instance passed to this function. This is a powerful feature that eliminates the need for users to create a separate hierarchy of subclasses that only alter the default properties of this class. Can also be used for skinning / styling purposes.

      Note: This method is intended for setting default attributes only and will affect all instances of the underlying class (including those automatically generated in JavaScript). This method should not be used to apply standard EventHandlers or override methods for a class - use a custom subclass instead. Calling this method after instances have been created can result in undefined behavior, since it bypasses any setters and a class instance may have already examined a particular property and not be expecting any changes through this route.

      Parameters:
        `relativeDateItemProperties` - properties that should be used as new defaults when instances of this class are created
      See Also:
        `SGWTProperties`

    - #### getRelativeDate

          public RelativeDate getRelativeDate()

      Returns the RelativeDate for the current value.
      Returns:
        the RelativeDate for the current value or null if not set

    - #### getAbsoluteDate

          public static java.util.Date getAbsoluteDate(RelativeDate relativeDate)

      Converts a RelativeDate to a concrete Date.
      Parameters:
        `relativeDate` - the relative date to convert
      Returns:
        resulting absolute date value

    - #### getAbsoluteDate

          public static java.util.Date getAbsoluteDate(RelativeDate relativeDate,
                                                       java.util.Date baseDate)

      Converts a RelativeDate to a concrete Date.
      Parameters:
        `relativeDate` - the relative date to convert
        `baseDate` - base value for conversion. Defaults to today
      Returns:
        resulting absolute date value

    - #### setPresetOptions

          public void setPresetOptions(java.util.LinkedHashMap valueMap)

      Set up a set of standard relative dates such as "today" or "tomorrow" that the user can choose directly from the valueField of this item.

      This is similar to a standard `FormItem::setValueMap(), valueMap` - the parameter passed in should be a HashMap mapping RelativeDate strings to display values. The default set of preset options (expressed in JSON) are:

           {
            "$today" : "Today",
            "$yesterday" : "Yesterday",
            "$tomorrow" : "Tomorrow",
            "-1w" : "Current day of last week",
            "+1w" : "Current day of next week",
            "-1m" : "Current day of last month",
            "+1m" : "Current day of next month"
            }

      In addition to these presets, options are shown for each of the `#setTimeUnitOptions,time unit options`.
      Parameters:
        -

    - #### setRangeRoundingGranularity

          public void setRangeRoundingGranularity(java.util.Map rangeRoundingGranularity)

      A map from a granularity of time specified by a user to the granularity of time used for rounding.

      A relative date such as "n days from now" is normally shifted to the end of the day when used as a range endpoint, and the beginning of the day when used as the beginning of a range. (The rounding direction on some item can be specified via +link{relativeDateItem.rangePosition}). This causes the intuitive behavior that "from yesterday to today" is from the beginning of yesterday to the end of today, and that "from today until 5 days from now" includes the entirety of Friday if today is Monday.

      This same rule can be applied to any time granularity, such that "from now until 20 minutes from now" is up to 5:32 if it is now 5:11:34, and "from now until 2 months from now" means end of June if it is mid-April.

      User intuitions about where this rounding is expected for any given time period tend to vary based on what kind of event is being discussed and subtle phrasing differences (consider "up to one year from now", "until next year", "within the next couple of years"). The defaults behaviors are:

      - for days, weeks and months round to day end/beginning
      - for hours, round to minute end/beginning
      - for minutes and seconds, round to second end/beginning
      To customize this rounding behavior, this attribute may be set to a Map mapping each timeUnit to the granularity for that timeUnit.
      For example the following config code would produce an item where the user could select only day or week values, and the selected value would be rounded to the beginning of the day if a day was selected, or the beginning of the week if a week was selected:

            RelativeDateItem fromDate = new RelativeDateItem("from");
            fromDate.setRangePosition(RelativeDateRangePosition.START);
            fromDate.setTimeUnitOptions(TimeUnit.DAY, TimeUnit.WEEK);

            Map roundingMap = new HashMap();
            roundingMap.put(TimeUnit.DAY, TimeUnit.DAY);
            roundingMap.put(TimeUnit.WEEK, TimeUnit.WEEK);
            fromDate.setRangeRoundingGranularity(roundingMap);

      Parameters:
        `rangeRoundingGranularity` -

    - #### setDateFormatter

          public void setDateFormatter(DateDisplayFormat dateFormatter)

      Format for displaying dates in the `valueField` and `calculatedDateField`. Defaults to the system-wide default established by Date.setShortDisplayFormat, or if this item has its type specified as datetime, Date.setShortDatetimeDisplayFormat.
      Overrides:
        `setDateFormatter` in class `FormItem`
      Parameters:
        `dateFormatter` - dateFormatter Default value is null
      See Also:
        `FormItem.setTimeFormatter(com.smartgwt.client.types.TimeDisplayFormat)`, `FormItem.setFormat(java.lang.String)`, `Appearance overview and related methods`

    - #### setDateFormatter

          public void setDateFormatter(DateDisplayFormatter formatter)

      Formatter function for displaying dates in the `valueField` and `calculatedDateField` in some custom format. Typically the `setDateParser(DateParser)` method should also be applied to ensure dates can be both formatted and edited date strings parsed back into actual date values.
      Parameters:
        `dateFormatter` - dateFormatter Default value is null

    - #### setDateParser

          public void setDateParser(DateParser parser)

      Custom date parser function for direct user input of date values. Typically used in conjunction with `setDateFormatter(DateDisplayFormatter)`.

      Note that `setDateFormatter(DateDisplayFormat)` and `setInputFormat(String)` already provide a mechanism for customizing the display format for date values displayed in this item.

    - #### setEditorValueParser

          public void setEditorValueParser(FormItemValueParser parser)

      RelativeDateItems do not make use of the standard FormItem.setEditorValueFormatter() and FormItem.setEditorValueParser() methods. Developers can customize the display values for these items in the following ways:
      - The RelativeDateItem.presetOptions map allows standard preset RelativeDateString and RelativeDateShortcut values to be mapped to custom display values
      - The text displayed for each of the RelativeDateItem.timeUnitOptions (e.g:"N days ago") may be customized via the per-time unit title attributes (RelativeDateItem.daysFromNowTitle, RelativeDateItem.daysAgoTitle, etc)
      - setDateFormatter and setInputFormat / setDateParser may be used modify how date values are displayed (both in the text entry box and in the calculatedDateField)
      Overrides:
        `setEditorValueParser` in class `FormItem`
      Parameters:
        `parser` - the FormItemValueParser

    - #### setEditorValueFormatter

          public void setEditorValueFormatter(FormItemValueFormatter formatter)

      RelativeDateItems do not make use of the standard FormItem.setEditorValueFormatter() and FormItem.setEditorValueParser() methods. Developers can customize the display values for these items in the following ways:
      - The RelativeDateItem.presetOptions map allows standard preset RelativeDateString and RelativeDateShortcut values to be mapped to custom display values
      - The text displayed for each of the RelativeDateItem.timeUnitOptions (e.g:"N days ago") may be customized via the per-time unit title attributes (RelativeDateItem.daysFromNowTitle, RelativeDateItem.daysAgoTitle, etc)
      - setDateFormatter and setInputFormat / setDateParser may be used modify how date values are displayed (both in the text entry box and in the calculatedDateField)
      Overrides:
        `setEditorValueFormatter` in class `FormItem`
      Parameters:
        `formatter` - the FormItemValueFormatter

    - #### getValueFieldComboBox

          public ComboBoxItem getValueFieldComboBox()

      `ComboBoxItem` field where a user may choose among `presets`, `time unit` plus `quantity`, or direct entry of a date as text.

      For an overview of how to use and configure AutoChildren, see `Using AutoChildren`.

      Returns:
        ComboBoxItem